//------------------------------------------------------------------

   #property copyright "mladen"
   #property link      "www.forex-tsd.com"

//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_plots   3

#property indicator_label1  "Centered TMA upper band"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrLimeGreen
#property indicator_style1  STYLE_DOT
#property indicator_label2  "Centered TMA"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrDarkGray
#property indicator_style2  STYLE_SOLID
#property indicator_width2  2
#property indicator_label3  "Centered TMA lower band"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrPaleVioletRed
#property indicator_style3  STYLE_DOT

//
//
//
//
//

input ENUM_TIMEFRAMES TimeFrame      = PERIOD_CURRENT; // Time frame
input int             HalfLength     = 50;             // Centered TMA half period
input double          BandMultiplier = 3;              // Multiplier for channel
input bool            Interpolate    = true;           // Interpolate in multi time frame mode?

double tmac[],tmah[],tmal[],count[];
ENUM_TIMEFRAMES timeFrame;

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int OnInit()
{
   SetIndexBuffer(0,tmah ,INDICATOR_DATA); 
   SetIndexBuffer(1,tmac ,INDICATOR_DATA); 
   SetIndexBuffer(2,tmal ,INDICATOR_DATA); 
   SetIndexBuffer(3,count,INDICATOR_CALCULATIONS); 

   //
   //
   //
   //
   //
            
         timeFrame = MathMax(_Period,TimeFrame);
   IndicatorSetString(INDICATOR_SHORTNAME," TMA centered ("+string(HalfLength)+")");
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{
   if (Bars(_Symbol,_Period)<rates_total) return(-1);

      //
      //
      //
      //
      //

      if (timeFrame!=_Period)
      {
         double result[]; datetime currTime[],nextTime[]; 
         static int indHandle =-1;
                if (indHandle==-1) indHandle = iCustom(_Symbol,timeFrame,getIndicatorName(),PERIOD_CURRENT,HalfLength,BandMultiplier);
                if (indHandle==-1)                          return(0);
                if (CopyBuffer(indHandle,3,0,1,result)==-1) return(0); 
             
                //
                //
                //
                //
                //
              
                #define _processed EMPTY_VALUE-1
                int i,limit = rates_total-(int)MathMin(result[0]*PeriodSeconds(timeFrame)/PeriodSeconds(_Period),rates_total); 
                for (limit=MathMax(limit,0); limit>0 && !IsStopped(); limit--) if (count[limit]==_processed) break;
                for (i=MathMin(limit,MathMax(prev_calculated-1,0)); i<rates_total && !IsStopped(); i++    )
                {
                   if (CopyBuffer(indHandle,0,time[i],1,result)==-1) break; tmah[i]  = result[0];
                   if (CopyBuffer(indHandle,1,time[i],1,result)==-1) break; tmac[i]  = result[0];
                   if (CopyBuffer(indHandle,2,time[i],1,result)==-1) break; tmal[i]  = result[0];
                                                                            count[i] = _processed;
                   
                   //
                   //
                   //
                   //
                   //
                   
                   #define _interpolate(buff,i,k,n) buff[i-k] = buff[i]+(buff[i-n]-buff[i])*k/n
                   if (!Interpolate) continue;  CopyTime(_Symbol,TimeFrame,time[i  ],1,currTime); 
                       if (i<(rates_total-1)) { CopyTime(_Symbol,TimeFrame,time[i+1],1,nextTime); if (currTime[0]==nextTime[0]) continue; }
                       int n,k;
                          for(n=1; (i-n)> 0 && time[i-n] >= currTime[0]; n++) continue;	
                          for(k=1; (i-k)>=0 && k<n; k++)
                          {
                             _interpolate(tmah,i,k,n);
                             _interpolate(tmal,i,k,n);
                             _interpolate(tmac,i,k,n);
                          }
                }
                if (i!=rates_total) return(0); return(rates_total);
      }

   //
   //
   //
   //
   //

   for (int i=(int)MathMax(prev_calculated-HalfLength,0); i<rates_total; i++)
   {
      tmac[i] = iCTma(close,HalfLength,i,rates_total);
         double rhi = iCTma(high,HalfLength,i,rates_total);;
         double rlo = iCTma(low ,HalfLength,i,rates_total);;
            tmah[i] = tmac[i]+(rhi-rlo)*BandMultiplier;;
            tmal[i] = tmac[i]-(rhi-rlo)*BandMultiplier;
   }      
   count[rates_total-1] = MathMax(rates_total-prev_calculated+1,1);
   return(rates_total);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double iCTma(const double& useValue[], int halfLength, int i, int bars)
{
   double sum  = (halfLength+1)*useValue[i];
   double sumw = (halfLength+1);
 
      //
      //
      //
      //
      //
 
      int j,k = halfLength; 
      for(j=1; j<=halfLength; j++,k--)
      {
         if (i-j>=0)
         {
            sum  += k*useValue[i-j];
            sumw += k;
         }
         if (i+j<bars)            
         {
            sum  += k*useValue[i+j];
            sumw += k;
         }               
      }
   return(sum/sumw);      
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string getIndicatorName()
{
   string progPath = MQL5InfoString(MQL5_PROGRAM_PATH); int start=-1;
   while (true)
   {
      int foundAt = StringFind(progPath,"\\",start+1);
      if (foundAt>=0) 
               start = foundAt;
      else  break;     
   }
   
   string indicatorName = StringSubstr(progPath,start+1);
          indicatorName = StringSubstr(indicatorName,0,StringLen(indicatorName)-4);
   return(indicatorName);
}

//
//
//
//
//

int    _tfsPer[]={PERIOD_M1,PERIOD_M2,PERIOD_M3,PERIOD_M4,PERIOD_M5,PERIOD_M6,PERIOD_M10,PERIOD_M12,PERIOD_M15,PERIOD_M20,PERIOD_M30,PERIOD_H1,PERIOD_H2,PERIOD_H3,PERIOD_H4,PERIOD_H6,PERIOD_H8,PERIOD_H12,PERIOD_D1,PERIOD_W1,PERIOD_MN1};
string _tfsStr[]={"1 minute","2 minutes","3 minutes","4 minutes","5 minutes","6 minutes","10 minutes","12 minutes","15 minutes","20 minutes","30 minutes","1 hour","2 hours","3 hours","4 hours","6 hours","8 hours","12 hours","daily","weekly","monthly"};
string timeFrameToString(int period)
{
   if (period==PERIOD_CURRENT) 
       period = _Period;   
         int i; for(i=0;i<ArraySize(_tfsPer);i++) if(period==_tfsPer[i]) break;
   return(_tfsStr[i]);   
}